%global namedreltag -SNAPSHOT
%global namedversion %{version}%{?namedreltag}

%ifarch x86_64 ia64 ppc64 sparc64 s390x alpha
%global libdir /usr/lib64
%else
%global libdir /usr/lib
%endif

Name:          hibernate-tools
Version:       3.6.0
Release:       0.1.20120812git%{?dist}
Summary:       Tools for Eclipse and Ant
Group:         Development/Libraries
License:       LGPLv2+
URL:           https://github.com/hibernate/hibernate-tools/
# git clone git://github.com/hibernate/hibernate-tools.git
# cd hibernate-tools/ && git checkout 3.6.x
# find hibernate-tools/ -name "*.class" -delete
# find hibernate-tools/ -name "*.jar" -delete
# tar czf hibernate-tools-3.6.0-SNAPSHOT-src-git.tar.gz hibernate-tools
Source0:       %{name}-%{namedversion}-src-git.tar.gz

Patch0:        %{name}-3.2.4.GA-updatefsfaddress.patch
# fix ant, cglib, freemarker and jtidy gId
# fix compiler plugin -target -source (1.5)
# use eclipse libraries as system dependency
Patch1:        %{name}-%{namedversion}-pom.patch

BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: jboss-parent

BuildRequires: ant
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-logging
# https://bugzilla.redhat.com/show_bug.cgi?id=806571
BuildRequires: cglib
BuildRequires: hibernate3
BuildRequires: hibernate3-entitymanager
BuildRequires: hibernate-commons-annotations >= 4.0.1
BuildRequires: hibernate-jpa-2.0-api
BuildRequires: eclipse-platform
BuildRequires: eclipse-rcp
# BR: org.eclipse.core.runtime_*.jar
# BR: org.eclipse.equinox.common_*.jar
# BR: org.eclipse.jdt.core_*.jar
# BR: org.eclipse.text_*.jar
BuildRequires: freemarker
BuildRequires: geronimo-jta
BuildRequires: javassist
BuildRequires: jtidy
BuildRequires: slf4j

BuildRequires: maven
BuildRequires: maven-antrun-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-build-helper
BuildRequires: maven-resources-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: properties-maven-plugin

# test deps
# BR: dom4j
# BR: hsqldb
# BR: javassist
# BR: jaxen
# BR: jboss-annotations-ejb3
# BR: jboss-archive-browsing
# BR: jboss-ejb3x
# BR: junit
# BR: mysql-connector-java
# BR: postgresql-jdbc

Requires:      ant
Requires:      apache-commons-collections
Requires:      apache-commons-logging
Requires:      cglib
Requires:      freemarker
Requires:      geronimo-jta
Requires:      hibernate3
Requires:      hibernate3-entitymanage
Requires:      hibernate-commons-annotations >= 4.0.1
Requires:      hibernate-jpa-2.0-api
Requires:      javassist
Requires:      jtidy
Requires:      slf4j

Requires:      java
Requires:      jpackage-utils
BuildArch:     noarch

%description
Forward- and reverse-engineering tools for Eclipse and Ant.

%package javadoc
Group:         Documentation
Summary:       Javadoc for %{name}
Requires:      jpackage-utils

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}
%patch0 -p0
%patch1 -p0

find . -name '*.jar' -delete
find . -name '*.class' -delete
sed -i 's/\r//' src/javadoc/jdstyle.css

# remove eclipse stuff
#rm src/java/org/hibernate/tool/ide/formatting/JavaFormatter.java
#rm src/java/org/hibernate/tool/ant/JavaFormatterTask.java
#rm src/test/org/hibernate/tool/ant/JavaFormatterTest.java
#rm src/test/org/hibernate/tool/test/TestHelper.java

%build

JDTVERSION=$(echo $(ls %{libdir}/eclipse/plugins | grep org.eclipse.jdt.core_ | sed 's/org.eclipse.jdt.core_//') | sed 's/.jar//')
TEXTVERSION=$(echo $(ls %{libdir}/eclipse/plugins | grep org.eclipse.text_ | sed 's/org.eclipse.text_//') | sed 's/.jar//')
CRVERSION=$(echo $(ls %{libdir}/eclipse/plugins | grep org.eclipse.core.runtime_ | sed 's/org.eclipse.core.runtime_//') | sed 's/.jar//')
ECVERSION=$(echo $(ls %{libdir}/eclipse/plugins | grep org.eclipse.equinox.common_ | sed 's/org.eclipse.equinox.common_//') | sed 's/.jar//')
# unavailable test deps
# jboss-archive-browsing
mvn-rpmbuild \
  -Dmaven.test.skip=true \
  -D_libdir=%{libdir} \
  -Djdt.version=$JDTVERSION \
  -Dtext.version=$TEXTVERSION \
  -Dcore.runtime.version=$CRVERSION \
  -Dequinox.common.version=$ECVERSION \
  javadoc:aggregate install

%install

mkdir -p %{buildroot}%{_javadir}
install -m 644 target/%{name}-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}.jar

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom %{name}.jar

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}

%files
%{_javadir}/%{name}.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%doc changelog.txt lgpl.txt readme.txt

%files javadoc
%{_javadocdir}/%{name}
%doc lgpl.txt

%changelog
* Sun Aug 12 2012 gil cattaneo <puntogil@libero.it> 3.6.0-0.1.20120812git
- Update to 3.6.0-SNAPSHOT

* Mon Jun 04 2012 gil cattaneo <puntogil@libero.it> 3.5.0-1
- Update to 3.5.0.Alpha-SNAPSHOT

* Tue Apr 10 2012 gil cattaneo <puntogil@libero.it> 3.2.4-1
- Initial rpm